This folder contains the code for running and visualizing the experiments presented in the main paper.
We used Python 3.7.6 to run the experiments. The required dependencies are listed in the **requirements.txt**
file and can be installed via
```shell script
pip install -r requirements.txt
```
Note that for running the maze and pick_and_place environments, you need MuJoCo and mujoco-py installed.
The Python wrapper mujoco-py can be installed via
```shell script
pip install mujoco-py==2.0.2.9
```
The experiments can be run via the **run.py** scripts. For convenience, we have created the 
**baseline_experiments.sh** and **self_paced_experiments.sh** scripts for running the experiments
of the baseline and SPRL algorithms.  To execute all experiments for on particular seed (in the example
below seed 1), you can run
```shell script
./baseline_experiments.sh 1
./self_paced_experiments.sh 1
```
After running the desired amount of seeds, you can visualize the results via
```shell script
cd misc
./visualizat_results.sh
```